dnl Process this file with aclocal to produce a aclocal.m4 file.  -*- Autoconf -*-

dnl This file is a part of SLEPOS project.
dnl Copyright (C) 2007  Petr Ostadal, SUSE / Novell Inc.
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2 of the License, or
dnl (at your option) any later version.
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.

# Fancy ARG_WITH for SLEPOS
dnl SLEPOS_ARG_WITH(OPTIONS, DEFAULT-VALUE, COMMENT)
AC_DEFUN([SLEPOS_ARG_WITH], 
[
  AC_ARG_WITH([$1], [AC_HELP_STRING([--with-$1], ifelse([$2], [], [$3], [$3 @<:@default=$2@:>@]))], 
    [slepos_cv_use_$1=$withval], [slepos_cv_use_$1=$2])
  AC_CACHE_CHECK([whether to use $1], [slepos_cv_use_$1], [slepos_cv_use_$1=$2
])
  define([_NAME],[translit([$1],[abcdefghijklmnopqrstuvwxyz./-],
                               [ABCDEFGHIJKLMNOPQRSTUVWXYZ___])])
  _NAME=$slepos_cv_use_$1
  undefine([_NAME])
])# SLEPOS_ARG_WITH

# Fancy ARG_ENABLE for SLEPOS
dnl SLEPOS_ARG_ENABLE(OPTIONS, DEFAULT-VALUE, COMMENT)
AC_DEFUN([SLEPOS_ARG_ENABLE], 
[
  AC_ARG_ENABLE([$1], [AC_HELP_STRING([--enable-$1], ifelse([$2], [], [$3], [$3 @<:@default=$2@:>@]))], 
    [slepos_cv_enable_$1="yes"], [slepos_cv_enable_$1=$2])
  AC_CACHE_CHECK([whether to enable $1], [slepos_cv_enable_$1], [slepos_cv_enable_$1=$2
])
  define([_NAME],[translit([$1],[abcdefghijklmnopqrstuvwxyz./-],
                               [ABCDEFGHIJKLMNOPQRSTUVWXYZ___])])
  _NAME=$slepos_cv_enable_$1
  undefine([_NAME])
])# SLEPOS_ARG_ENABLE

# Checks for pogram/command
dnl SLEPOS_PROG_ARG(PROGRAM, [SEARCH_PATH], [COMMENT], [NEEDED])
AC_DEFUN([SLEPOS_PROG_ARG],
[
  define([Name],[translit([$1],[./-], [___])])
  define([NAME],[translit([$1],[abcdefghijklmnopqrstuvwxyz./-],
                               [ABCDEFGHIJKLMNOPQRSTUVWXYZ___])])

#  SLEPOS_ARG_ENABLE([Name], ifelse([$2], [], [], [yes]), [enable $1 program ifelse([$3], [] ,[],[($3)])])
  slepos_needed=$4
#  slepos_cv_use_$1="yes"
  SLEPOS_ARG_WITH(Name, [$2], [use $1 program ifelse([$3], [] ,[],[($3)])])

  AC_MSG_CHECKING([for $1])
  have_prog_[]Name="no"
  path_prog_[]Name=""
  if test "x$slepos_cv_use_$1" = "xno"; then
    AC_MSG_WARN([support of $1 program is disabled])
  else
    if test -n "$slepos_cv_use_$1"; then
      if test -d "$slepos_cv_use_$1"; then
        AC_PATH_PROG([path_prog_]Name, [$1], [], ["$slepos_cv_use_$1"])[]dnl
      else
        if test -x "$slepos_cv_use_$1"; then
          path_prog_[]Name="$slepos_cv_use_$1"
        else
          if test "x$slepos_needed" = "xno"; then
            AC_MSG_WARN([Could not find prog $1 or it is not executable])
          else
            AC_MSG_ERROR([Could not find prog $1 or it is not executable])
          fi
        fi
      fi
    else
      AC_PATH_PROG([path_prog_]Name, [$1])[]dnl
    fi
    if test -z "$path_prog_[]Name"; then
      AC_MSG_WARN([$1 program was not found, support of $1 program is disabled])
    else     
      have_prog_[]Name="yes"
      AC_DEFINE_UNQUOTED([HAVE_PROG_]NAME, 1, [Defined if $1 program is installed])
      AC_DEFINE_UNQUOTED([PROG_]NAME, ["$path_prog_[]Name"], [Defined pathname of program $1])
    fi
  fi
  AC_MSG_RESULT([$have_prog_[]Name])
  undefine([Name])
  undefine([NAME])
])# SLEPOS_PROG_ARG
