#!/bin/bash
#
# This script is executed at the end of appliance creation.  Here you can do
# one-time actions to modify your appliance before it is ever used, like
# removing files and directories to make it smaller, creating symlinks,
# generating indexes, etc.
#
# The kiwi_type variable will contain the format of the appliance
# (oem = disk image, vmx = VMware, iso = CD/DVD, xen = Xen).
#

# read in some variables
. /studio/profile

# read in KIWI utility functions
. /.kconfig

#======================================
# Prune extraneous files
#--------------------------------------
# Remove all documentation
docfiles=`find /usr/share/doc/packages -type f |grep -iv "copying\|license\|copyright"`
rm -f $docfiles
rm -rf /usr/share/info
rm -rf /usr/share/man

baseStripLocales $kiwi_language

#do not agree with license on each image change
rm -f /etc/YaST2/licenses/license.txt

# enable audible bell
gconftool-2 --direct --config-source=xml::/etc/gconf/gconf.xml.defaults --set /apps/metacity/general/audible_bell --type=bool true

# finalize the gconf tree
gconf-merge-tree /etc/gconf/gconf.xml.defaults

# created links for all supported busybox apps if it was installed
baseSetupBusyBox

# enable manager registration init script if the package is present
if [ -f /etc/init.d/suse_manager_client_registration ] ; then
    suseInsertService suse_manager_client_registration
fi

exit 0

